libname feb "c:\ethanol\feb05\renorm";

OPTIONS LS=79 ps=59;

/* MACRO to run mixed model variants */
/* In all these cases, fixed and random interaction terms are the same (no weights)
so we don't need to have fterms and rterms in macro calls  */

%macro runmix(data, method, code, fterms);

PROC MIXED DATA=&data MAXITER=500 METHOD=&method NOCLPRINT ic;
CLASS NEW noxcat2;
TITLE "Code &code : NOx model using &data with method &method";
title2 "and terms &fterms";

MODEL LN_NOX = RV T5 T9 AR OL OX SU 
               &fterms
               /S DDFM=RES;

RANDOM        
INT
RV T5 T9 AR OL OX SU
&fterms
/SUB=NEW;
run;


%mend runmix;

%macro runmix2(data, method, code, fterms);

PROC MIXED DATA=&data MAXITER=500 METHOD=&method NOCLPRINT ic;
CLASS NEW noxcat2;
TITLE "Code &code : NOx model using &data with method &method";
title2 "and terms &fterms";

MODEL LN_NOX = noxcat2 RV T5 T9 AR OL OX SU 
               &fterms
               /S DDFM=RES;

RANDOM  RV T5 T9 AR OL OX SU
&fterms /SUB=NEW;
random int / group = noxcat2 sub=new;
run;


%mend runmix2;

%macro main;

/* need to use consistent normalizations for mle comparisons */

data normal higher;
set feb.icfall;
if noxcat2="Normal" then output normal;
else output higher;
run;


    %runmix(feb.icfall, ml, arb10, suox t5ox t5t5 rvt9 rvol t5ol arar oxox arsu t9ar olol rvsu olsu);
    %runmix2(feb.icfall, ml, arb10 + veh, suox t5ox t5t5 rvt9 rvol t5ol arar oxox arsu t9ar olol rvsu olsu);
    %runmix(feb.normal, ml, normal normed by self, t9ox oxox suox t5t5 t9ar rvar rvox olol rvt9 t9su t5ol);
    %runmix(normal, ml, normal normed by icf, t9ox oxox suox t5t5 t9ar rvar rvox olol rvt9 t9su t5ol);
    %runmix(normal, ml, normal + arb10 normed by icf, t9ox oxox suox t5t5 t9ar rvar rvox olol rvt9 t9su t5ol t5ox rvol arar arsu rvsu olsu);
    %runmix(feb.higher, ml, higher normed by self, rvox t9ol rvt5 rvsu rvt9 arox arol t5ol rvrv);
    %runmix(higher, ml, higher normed by icf, rvox t9ol rvt5 rvsu rvt9 arox arol t5ol rvrv);
    %runmix(higher, ml, higher + arb10 normed by icf, rvox t9ol rvt5 rvsu rvt9 arox arol t5ol rvrv suox t5ox t5t5 rvol arar oxox arsu t9ar olol olsu);  

%mend main;

%main
